#!/usr/bin/env python

def backtrack(backptr, index, seq):
	if backptr[index] == -1:
		return seq[index]
	return "%s %s" % (backtrack(backptr, backptr[index], seq), seq[index])
	
def liss(seq):
	max_len = 1
	longest = []
	backptr = []
	for i in range(len(seq)):
		longest.append(1)
		backptr.append(-1)
	for i in range(1, len(seq)):
		for j in range(i-1, -1, -1):
			if longest[j] + 1 > longest[i] and seq[j] < seq[i]:
				longest[i] = longest[j] + 1
				backptr[i] = j
		if longest[i] > max_len:
			final_index = i
			max_len = longest[i]
	return backtrack(backptr, final_index, seq)

if __name__ == "__main__":
	seq = [5,1,2,3,4]
	print liss(seq)
	