#!/usr/bin/env python

def qsort(arr):
    if arr == []: 
        return []
    else:
        pivot = arr[0]
        lesser = [x for x in arr[1:] if x < pivot] # list comprehension
        greater = [x for x in arr[1:] if x >= pivot]
        return qsort(lesser) + [pivot] + qsort(greater)

if __name__ == "__main__" :
	print qsort([5,9,2,1,3])
	# worst-case : already sorted array
	#			[5,10,15,20,25,30,35,40,45,50,55,60,65,70,75]
	# best-case : when pivot is exactly in the middle for every sub-array
	#			[40,35,75,45,5,25,65,20,60,15,70,50,10,55,30]